--- linux-2.6.27.6/include/asm-mips/delay.h	2008-11-14 01:56:21.000000000 +0800
+++ linux-2.6.27.6.yaffs/include/asm-mips/delay.h	2011-05-08 18:02:30.000000000 +0800
@@ -82,12 +82,14 @@
 		: "=h" (usecs), "=l" (lo)
 		: "r" (usecs), "r" (lpj)
 		: GCC_REG_ACCUM);
-	else if (sizeof(long) == 8 && !R4000_WAR)
-		__asm__("dmultu\t%2, %3"
-		: "=h" (usecs), "=l" (lo)
-		: "r" (usecs), "r" (lpj)
-		: GCC_REG_ACCUM);
-	else if (sizeof(long) == 8 && R4000_WAR)
+	else if (sizeof(long) == 8 && !R4000_WAR){
+		//__asm__("dmultu\t%2, %3"
+		//: "=h" (usecs), "=l" (lo)
+		//: "r" (usecs), "r" (lpj)
+		//: GCC_REG_ACCUM);
+		typedef unsigned int uint128_t __attribute__((mode(TI)));
+		usecs = ((uint128_t) usecs * lpj) >> 64;
+	}else if (sizeof(long) == 8 && R4000_WAR)
 		__asm__("dmultu\t%3, %4\n\tmfhi\t%0"
 		: "=r" (usecs), "=h" (hi), "=l" (lo)
 		: "r" (usecs), "r" (lpj)
